/**
 * @license rand
 * (c) 2019 tom
 * License: MIT
*/
import rand from "@tomsd/rand";
import serial from "@tomsd/serial";
import Tags from "@tomsd/tags.js";
import moment from "moment";
import "bootstrap/dist/css/bootstrap.min.css";
import "bootstrap";

export default {
  displayNavBar:gennavbar,
  displaySpinner:displayspinner,
  displaySideBar:gensidebar,
  displayModal:displaymodal,
  util:{
    toggleswitch:generatetoggleswitch,
    datepicker:c_chooseday,
    timepicker:c_choosetime,
    select:c_select,
    moment:moment
  }
};

window.addEventListener("load", function(){
    document.getElementsByTagName("head")[0].appendChild(document.createElement("style")).innerHTML = ".sidebar {position:fixed; top:0; left:0; bottom:0; z-index:100; box-shadow:inset -1px 0 0 rgba(0,0,0,0.1);}";
});

function removemain(){
  [".container-sidebar","main"].map(function(cn){
    Array.from(document.querySelectorAll(cn)).map(function(ele){try{ele.parentNode.removeChild(ele);}catch(e){}});
  });
}
function displayspinner(textclass){let mainarea = document.querySelector("main") ? document.querySelector("main") : document.body.appendChild(Tags.main({role:"main"},{paddingTop:"4.5rem"})); mainarea.innerHTML = ""; mainarea.appendChild(Tags.div({class:"container-fluid"})).appendChild(Tags.div({class:"row justify-content-center align-items-center"})).appendChild(Tags.div({class:"spinner-border "+(textclass ? textclass : "text-secondary")})); return mainarea;}

function gennavbar(navo){
  if(!navo){navo = {};}
  if("version" in navo){
    switch(navo.version){
      default:{return gennav2(navo);break;}
    }
  }else{return gennav2(navo);}
}
function adjustnavo2(navo){
  navo.colorpole = navo.colorpole ? navo.colorpole : "light";
  if(!navo.classes){navo.classes = {};}
  ["navbar","brand","menu_li","menu_a","dropdownmenu","dropdownitem","spinner"].map(function(s){
    if(!navo.classes[s]){navo.classes[s] = [];}
  });
  if(!navo.menu){navo.menu = [];}
  if(!navo.brand){navo.brand = {};}
  if(!navo.brand.href){navo.brand.href = "#";}
  if(!navo.brand.title){navo.brand.title = "";}
}
function gennav2(navo){
  adjustnavo2(navo);
  const lcolorpole = (function(cp){try{let s = cp.toLowerCase(); return ["light","dark"].indexOf(s) >= 0 ? s : "light";}catch(e){}})(navo.colorpole);
  //const lcolorpole = navo.colorpole && (navo.colorpole.toLowerCase() === "light" || navo.colorpole.toLowerCase() === "dark") ? navo.colorpole.toLowerCase() : "light";
  const navdivid = rand.id(), navbar = document.body.appendChild(Tags.nav({class:["navbar","navbar-expand-md","fixed-top","navbar-"+lcolorpole].concat(navo.classes.navbar).filter(Boolean).join(" ")}));
  const brandanc = navbar.appendChild(Tags.a({class:["navbar-brand"].concat(navo.classes.brand).filter(Boolean).join(" "), href:navo.brand.href}));
  if(navo.brand && navo.brand.icon){
    if(navo.brand.icon.html){brandanc.innerHTML = navo.brand.icon.html;}else{
      const brand_imgattr = {src:navo.brand.icon.src, class:"mr-1"};
      ["width","height"].map(function(pn){if(navo.brand.icon[pn]){brand_imgattr[pn] = navo.brand.icon[pn];}});
      brandanc.appendChild(Tags.img(brand_imgattr));
    }
  }
  brandanc.innerHTML += navo.brand.title;
  const toggler = navbar.appendChild(Tags.button({class:"navbar-toggler",type:"button","data-toggle":"collapse","data-target":"#"+navdivid, "aria-controls":navdivid, "aria-expanded":"false","aria-label":"toggle navigation"})); toggler.appendChild(Tags.span({class:"navbar-toggler-icon"}));
  const navdiv = navbar.appendChild(Tags.div({class:"collapse navbar-collapse", id:navdivid}));
  const menuul = navdiv.appendChild(Tags.ul({class:"navbar-nav mr-auto"}));
  //const menuul_right = navdiv.appendChild(Tags.ul({class:"navnar-nav"}));
  const rightarea = navdiv.appendChild(Tags.div());
  let ancs = [];
  [
    {menu:navo.menu,menuul:menuul}
    //,{menu:navo.menu_right,menuul:menuul_right}
  ].map(function(mset){
    ancs = ancs.concat(mset.menu.map(function(set){
      if(!set.type){set.type = "executable";}
      if(!set.classes){set.classes = {};}
      if(!set.classes.li){set.classes.li = [];}
      if(!set.classes.a){set.classes.a = [];}
      const itisdd = set.type && set.type.toLowerCase() === "dropdown";
      const li = mset.menuul.appendChild(Tags.li({class:["nav-item"].concat(navo.classes.menu_li).concat(set.classes.li).concat([itisdd ? "dropdown" : null]).filter(Boolean).join(" ")}));
      const coordinateactivestate = c_coordinateactivestate(set.title);
      function refreshmain(){removemain(); let mainarea = document.body.appendChild(Tags.main({role:"main"},{paddingTop:"4.5rem"})); mainarea.appendChild(Tags.div({class:"container-fluid mt-3"})).appendChild(Tags.div({class:"row justify-content-center align-items-center"})).appendChild(Tags.div({class:["spinner-border"].concat(navo.classes.spinner).filter(Boolean).join(" ")})); return mainarea;}
      if(itisdd){
        const ddancid = rand.id(), ddanc = li.appendChild(Tags.a({href:"#",id:ddancid,class:["nav-link","dropdown-toggle"].concat(navo.classes.menu_a).concat(set.classes.a).join(" "),role:"button","data-toggle":"dropdown","aria-haspopup":"true","aria-expanded":"false"})); ddanc.innerHTML = set.title;
        const dddiv = li.appendChild(Tags.div({class:["dropdown-menu"].concat(navo.classes.dropdownmenu).filter(Boolean).join(" "),"aria-labelledby":ddancid}));
        set.dropdowns.map(function(dropdownitem){
          if(!dropdownitem.classes){dropdownitem.classes = {a:[]};}
          const dditemanc = dddiv.appendChild(Tags.a({class:["dropdown-item"].concat(navo.classes.dropdownitem).concat(dropdownitem.classes.a).filter(Boolean).join(" "),href:"#"})); dditemanc.innerHTML = dropdownitem.title;
          dditemanc.addEventListener("click", function(){dropdownitem.onclick(refreshmain()); coordinateactivestate(); if(navdiv.classList.contains("show")){toggler.click();} });
        }); return ddanc;
      }else{
        const anc = li.appendChild(Tags.a({href:"#",class:["nav-link"].concat(navo.classes.menu_a).concat(set.classes.a).filter(Boolean).join(" ")})); anc.innerHTML = set.title;
        anc.addEventListener("click", function(){set.onclick(refreshmain()); coordinateactivestate(); if(navdiv.classList.contains("show")){toggler.click();} });
        if(set.default){setTimeout(function(){anc.click();},1);}
        return anc;
      }
    }));
  });
  function c_coordinateactivestate(v){return function(){
    ancs.map(function(tanc){tanc.classList.remove("active");});
    ancs.filter(function(tanc){return v === tanc.innerHTML;}).map(function(tanc){tanc.classList.add("active");});
  };}
  return {div:navdiv,ul:menuul,rightarea:rightarea};
}
function gensidebar(set){
  if(!set){set = {};}
  if(set.version){
    switch(set.version){
      default:{gensidebar2(set);break;}
    }
  }else{gensidebar2(set);}
}
function adjustsidebardef2(set){
  if(!set.classes){set.classes = {};}
  if(!set.classes.sidebar){set.classes.sidebar = [];}
  if(!set.classes.menu_ul){set.classes.menu_ul = [];}
  if(!set.classes.menu_li){set.classes.menu_li = [];}
  if(!set.classes.menu_a){set.classes.menu_a = [];}
  if(!set.classes.spinner){set.classes.spinner = [];}
}
function gensidebar2(set){
  adjustsidebardef2(set);
  removemain();
  const row = document.body.appendChild(Tags.div({class:"container-sidebar container-fluid h-100"})).appendChild(Tags.div({class:"row h-100"}));
  const sidebar = row.appendChild(Tags.div({class:["col-md-2","d-none","d-md-block","sidebar"].concat(set.classes.sidebar).filter(Boolean).join(" ")}));
  const menuul = sidebar.appendChild(Tags.div({class:"sidebar-sticky"},{paddingTop:"5rem"})).appendChild(Tags.ul({class:["nav","flex-column"].concat(set.classes.menu_ul).filter(Boolean).join(" ")}));
  const mainarea = row.appendChild(Tags.main({class:"col-md-9 ml-sm-auto col-lg-10 px-4",role:"main"},{paddingTop:"5rem"}));
  function refreshmain(){mainarea.innerHTML = ""; mainarea.appendChild(Tags.div({class:"container-fluid"})).appendChild(Tags.div({class:"row justify-content-center align-items-center"})).appendChild(Tags.div({class:["spinner-border"].concat(set.classes.spinner).filter(Boolean).join(" ")})); return mainarea;}
  let ancs = [];
  ancs = set.menu.map(function(mitem){
    if(!mitem.classes){mitem.classes = {};}
    if(!mitem.classes.li){mitem.classes.li = [];}
    if(!mitem.classes.a){mitem.classes.a = [];}
    const li = menuul.appendChild(Tags.li({class:["nav-item"].concat(set.classes.menu_li).concat(mitem.classes.li).filter(Boolean).join(" ")}));
    const anc = li.appendChild(Tags.a({href:"#",class:["nav-link"].concat(set.classes.menu_a).concat(mitem.classes.a).filter(Boolean).join(" ")}));
    if(mitem.icon){
      if(mitem.icon.html){anc.innerHTML = mitem.icon.html;}else{
        let imgattr = {src:mitem.icon.src}; ["width","height"].map(function(pn){if(mitem.icon[pn]){imgattr[pn] = mitem.icon[pn];} });
        anc.appendChild(Tags.img(imgattr));
      }
    } anc.innerHTML += mitem.title;
    anc.addEventListener("click", function(){coordinateactivestate(mitem); mitem.onclick(refreshmain());});
    if(mitem.default){setTimeout(function(){anc.click();},1);}
    return {elm:anc, mitem:mitem};
  });
  function coordinateactivestate(mitem){
    ancs.map(function(tanc){tanc.elm.classList.remove("active");});
    ancs.filter(function(tanc){return mitem.title === tanc.mitem.title;}).map(function(tanc){tanc.elm.classList.add("active");});
  }
}

function displaymodal(set){
  if(!set){set = {};}
  if(set.version){
    switch(set.version){
      default:{return displaymodal2(set);break;}
    }
  }else{return displaymodal2(set);}
}

function adjustmodaldef2(set){
  if(!("backdrop" in set)){set.backdrop = true;}
  if(!set.classes){set.classes = {};}
  ["dialog","document","content","header","title","body","footer","closebutton"].map(function(s){
    if(!set.classes[s]){set.classes[s] = [];}
  });
  if(!set.header){set.header = {};}
  if(!set.header.title){set.header.title = "";}
  if(!set.body){set.body = {};}
  if(!set.body.text){set.body.text = "";}
  if(!set.closebutton){set.closebutton = {};}
  if(!set.closebutton.text){set.closebutton.text = "close";}
}

function displaymodal2(set){
  adjustmodaldef2(set);
  const mid = rand.id(), modaldiv = document.body.appendChild(Tags.div({id:mid, tabindex:"-1",role:"dialog",class:["modal","fade"].concat(set.classes.dialog).filter(Boolean).join(" ")}));
  const closef = function(){try{modaldiv.parentNode.removeChild(modaldiv);}catch(e){}};
  const modaldocument = modaldiv.appendChild(Tags.div({role:"document",class:["modal-dialog","modal-dialog-centered","modal-dialog-scrollable"].concat(set.classes.document).filter(Boolean).join(" ")}));
  const modalcontent = modaldocument.appendChild(Tags.div({class:["modal-content"].concat(set.classes.content).filter(Boolean).join(" ")}));
  const modalheader = modalcontent.appendChild(Tags.div({class:["modal-header"].concat(set.classes.header).filter(Boolean).join(" ")}));
  modalheader.appendChild(Tags.h5({class:["modal-title"].concat(set.classes.title).filter(Boolean).join(" ")})).innerHTML = set.header.title;
  const modalbody = modalcontent.appendChild(Tags.div({class:["modal-body"].concat(set.classes.body).filter(Boolean).join(" ")})); modalbody.innerHTML = set.body.text;
  const modalfooter = modalcontent.appendChild(Tags.div({class:["modal-footer"].concat(set.classes.footer).filter(Boolean).join(" ")}));
  const closebutt = modalfooter.appendChild(Tags.button({type:"button","data-dismiss":"modal",class:["btn"].concat(set.classes.closebutton).filter(Boolean).join(" ")})); closebutt.innerHTML = set.closebutton.text;
  closebutt.addEventListener("click", closef);
  const tempbutt = document.body.appendChild(Tags.button({type:"button",class:"btn","data-toggle":"modal","data-backdrop":set.backdrop,"data-target":"#"+mid}));
  tempbutt.addEventListener("click", function(){tempbutt.parentNode.removeChild(tempbutt);}); tempbutt.click();
  return {header:modalheader, body:modalbody, footer:modalfooter, close:function(){closebutt.click();}};
}

function generatetoggleswitch(set){
  if(set.version){
    switch(set.version){
      default:{return generatetoggleswitch2(set);break;}
    }
  }else{return generatetoggleswitch2(set);}
}

function adjusttoggleswitchdef2(set){
  if(!set.classes){set.classes = {};}
  if(!set.classes.switch){set.classes.switch = [];}
  if(!set.classes.checkbox){set.classes.checkbox = [];}
  if(!set.classes.label){set.classes.label = [];}
  if(!set.label){set.label = {};}
  if(!set.label.text){set.label.text = {};}
  if(!set.label.text.iftrue){set.label.text.iftrue = "on";}
  if(!set.label.text.iffalse){set.label.text.iffalse = "off";}
  if(!set.label.classes){set.label.classes = {};}
  if(!set.label.classes.iftrue){set.label.classes.iftrue = [];}
  if(!set.label.classes.iffalse){set.label.classes.iffalse = [];}
}

function generatetoggleswitch2(set){
  adjusttoggleswitchdef2(set);
  const checkboxid = rand.id(), rdiv = Tags.div({class:["custom-control","custom-switch"].concat(set.classes.switch).filter(Boolean).join(" ")});
  const mycheckbox = rdiv.appendChild(Tags.input({id:checkboxid,type:"checkbox",class:["custom-control-input"].concat(set.classes.checkbox).filter(Boolean).join(" ")}));
  const label = rdiv.appendChild(Tags.label({for:checkboxid,class:["custom-control-label"].concat(set.classes.label).filter(Boolean).join(" ")}));
  label.innerHTML = mycheckbox.checked ? set.label.text.iftrue : set.label.text.iffalse;
  mycheckbox.addEventListener("change", reflectchange);
  function reflectchange(){
    label.innerHTML = mycheckbox.checked ? set.label.text.iftrue : set.label.text.iffalse;
    (function(tempo){
      tempo.toremove.map(function(cn){label.classList.remove(cn);});
      tempo.toadd.map(function(cn){label.classList.add(cn);});
    })(
      mycheckbox.checked ? {toadd:set.label.classes.iftrue, toremove:set.label.classes.iffalse} : {toadd:set.label.classes.iffalse, toremove:set.label.classes.iftrue}
    );
    if(set.functions && set.functions.onchange){set.functions.onchange(mycheckbox.checked);}
  }
  return {div:rdiv,box:mycheckbox,reflect:reflectchange};
}

function adjustdatepickerdefinition(set){
  if(!set.classes){set.classes = {};}
  ["prevmonth","currentmonth","nextmonth"].map(function(s){
    if(!set.classes[s]){set.classes[s] = [];}
  });
  if(!set.classes.daycard){set.classes.daycard = {};}
  ["card","header","body","footer"].map(function(s){
    if(!set.classes.daycard[s]){set.classes.daycard[s] = [];}
  });
  ["prevmonth","currentmonth","nextmonth"].map(function(s){
    if(!set[s]){set[s] = {};}
    if(!set[s].gettext){set[s].gettext = function(pdate){return moment(pdate).format("YYYY.MM");};}
  });
  if(!set.daycard){set.daycard = {};}
  if(!set.daycard.card){set.daycard.card = {};}
  if(!set.daycard.card.getclasses){set.daycard.card.getclasses = function(pdate,first_day_of_month){return [];};}
  if(!set.daycard.header){set.daycard.header = {};}
  if(!set.daycard.header.gettext){set.daycard.header.gettext = function(pdate,first_day_of_month){return moment(pdate).format("DD");};}
  if(!set.daycard.header.getclasses){set.daycard.header.getclasses = function(pdate,first_day_of_month){
    if(moment(pdate).format("YYYYMM") !== moment(first_day_of_month).format("YYYYMM")){return ["text-secondary"];}
    return [
      [
        "text-danger","text-success","text-success","text-success","text-success","text-success","text-info"
      ][moment(pdate).format("d")]
    ];
  };}
  if(!set.daycard.body){set.daycard.body = {};}
  if(!set.daycard.body.gettext){set.daycard.body.gettext = function(pdate,first_day_of_month){return "";};}
  if(!set.daycard.body.getclasses){set.daycard.body.getclasses = function(pdate,first_day_of_month){return [];};}
  if(!set.daycard.footer){set.daycard.footer = {};}
  if(!set.daycard.footer.gettext){set.daycard.footer.gettext = function(pdate,first_day_of_month){return "";};}
  if(!set.daycard.footer.getclasses){set.daycard.footer.getclasses = function(pdate,first_day_of_month){return [];};}
  if(!set.functions){set.functions = {};}
  if(!set.functions.postdisplay){set.functions.postdisplay = function(){};}
}

function getdays(pdate){
  let ldate = pdate ? pdate : new Date(), fdom = new Date(ldate.getFullYear(), ldate.getMonth(), 1,0,0,0), ldom = new Date(fdom.getFullYear(), fdom.getMonth()+1, 0,0,0,0);
  let fdoc = new Date(fdom.getFullYear(), fdom.getMonth(), fdom.getDate() - fdom.getDay(), 0,0,0), ldoc = new Date(ldom.getFullYear(), ldom.getMonth(), ldom.getDate()+6-ldom.getDay(),0,0,0);
  let prevm = new Date(ldate.getFullYear(), ldate.getMonth()-1, 1,0,0,0), nextm = new Date(ldate.getFullYear(), ldate.getMonth()+1,1,0,0,0);
  let days = [], cday = fdoc,lastdayofc = moment(ldoc).format("YYYYMMDD");
  while(moment(cday).format("YYYYMMDD") <= lastdayofc){
    days.push(cday);
    cday = new Date(cday.getFullYear(), cday.getMonth(), cday.getDate() + 1, 0,0,0);
  }
  return {prevmonth:prevm,currentmonth:fdom,nextmonth:nextm,days:days};
}

function c_chooseday(set){adjustdatepickerdefinition(set); return function(area,pdate){return new Promise(function(resolve,reject){
  (function reflect(pdate){
    let calo = getdays(pdate);
    area.innerHTML = "";
    let basebox = area.appendChild(Tags.div({class:"w-100 d-flex flex-row flex-nowrap justify-content-center"})).appendChild(Tags.div({},{width:"95%"}));
    let month_fbox = basebox.appendChild(Tags.div({class:"container-fluid mb-2"})).appendChild(Tags.div({class:"row"}));
    let prev = month_fbox.appendChild(Tags.button({type:"button",class:["col","btn"].concat(set.classes.prevmonth).filter(function(s){return s && s !== "";}).join(" ")})); prev.innerHTML = set.prevmonth.gettext(calo.prevmonth);
    month_fbox.appendChild(Tags.div({class:["col"].concat(set.classes.currentmonth).filter(function(s){return s && s !== "";}).join(" ")})).innerHTML = set.currentmonth.gettext(calo.currentmonth);
    let next = month_fbox.appendChild(Tags.button({type:"button",class:["col","btn"].concat(set.classes.nextmonth).filter(function(s){return s && s !== "";}).join(" ")})); next.innerHTML = set.nextmonth.gettext(calo.nextmonth);
    prev.addEventListener("click", function tempprev(){reflect(calo.prevmonth);});
    next.addEventListener("click", function tempnext(){reflect(calo.nextmonth);});
    let day_fbox = null, di = 0, myw = Math.floor((basebox.getBoundingClientRect().width - 15) / 7);
    calo.days.map(function(day){
      if(di % 7 === 0){
        day_fbox = basebox.appendChild(Tags.div({class:"container-fluid"})).appendChild(Tags.div({class:"row"}));
      }
      let daycard = day_fbox.appendChild(Tags.div({class:["card"].concat(set.classes.daycard.card).concat(set.daycard.card.getclasses(day,calo.currentmonth)).filter(function(s){return s && s !== "";}).join(" ")},{width:myw+"px",height:myw+"px"}));
      let header = daycard.appendChild(Tags.div({class:["card-header"].concat(set.classes.daycard.header).concat(set.daycard.header.getclasses(day,calo.currentmonth)).filter(function(s){return s && s !== "";}).join(" ")}));
      header.innerHTML = set.daycard.header.gettext(day,calo.currentmonth);
      let body = daycard.appendChild(Tags.div({class:["card-body"].concat(set.classes.daycard.body).concat(set.daycard.body.getclasses(day,calo.currentmonth)).filter(function(s){return s && s !== "";}).join(" ")}));
      body.innerHTML = set.daycard.body.gettext(day,calo.currentmonth);
      let footer = daycard.appendChild(Tags.div({class:["card-footer"].concat(set.classes.daycard.footer).concat(set.daycard.footer.getclasses(day,calo.currentmonth)).filter(function(s){return s && s !== "";}).join(" ")}));
      footer.innerHTML = set.daycard.footer.gettext(day,calo.currentmonth);
      daycard.addEventListener("click", function(){area.innerHTML = ""; resolve(day);});
      di++;
    });
    if(set.functions.postdisplay){set.functions.postdisplay();}
  })(new Date());
});};}

function adjusttimedefinition(set){
  if(!set){set = {};}
  if(!set.classes){set.classes = {};}
  ["colordiv","colondiv","minutediv","numberbutton","undobutton","okbutton","cancelbutton"].map(function(s){
    if(!set.classes[s]){set.classes[s] = [];}
  });
  if(!set.buttons){set.buttons = {};}
  if(!set.buttons.undo){set.buttons.undo = {};}
  if(!set.buttons.undo.text){set.buttons.undo.text = "&lt;";}
  if(!set.buttons.ok){set.buttons.ok = {};}
  if(!set.buttons.ok.text){set.buttons.ok.text = "OK";}
  if(!set.buttons.cancel){set.buttons.cancel = {};}
  if(!set.buttons.cancel.text){set.buttons.cancel.text = "CANCEL";}
}

function c_choosetime(set){adjusttimedefinition(set); return function(area,pdate){return new Promise(function(resolve,reject){
  area.innerHTML = "";
  let ldate = pdate ? pdate : (new Date(2000,1,1,0,0,0));
  const basebox = area.appendChild(Tags.div({class:"w-100 d-flex flex-row flex-nowrap justify-content-center"})).appendChild(Tags.div({},{width:"95%"}));
  const inputrow = basebox.appendChild(Tags.div({class:"container-fluid"})).appendChild(Tags.div({class:"row"}));
  const hourbox = inputrow.appendChild(Tags.div({class:["col"].concat(set.classes.hourdiv).filter(Boolean).join(" ")})); hourbox.innerHTML = moment(ldate).format("HH");
  inputrow.appendChild(Tags.div({class:["col","text-center"].concat(set.classes.colondiv).filter(Boolean).join(" ")})).innerHTML = ":";
  const minutebox = inputrow.appendChild(Tags.div({class:["col"].concat(set.classes.minutediv).filter(Boolean).join(" ")})); minutebox.innerHTML = moment(ldate).format("mm");
  const okbutton = inputrow.appendChild(Tags.button({class:["col","btn"].concat(set.classes.okbutton).filter(Boolean).join(" ")})); okbutton.innerHTML = set.buttons.ok.text;
  okbutton.addEventListener("click", function(){let rdate = new Date(2000,1,1,parseInt(hourbox.innerHTML,10), parseInt(minutebox.innerHTML,10),0); area.innerHTML = ""; resolve(rdate);});
  const cancelbutton = inputrow.appendChild(Tags.button({class:["col","btn"].concat(set.classes.cancelbutton).filter(Boolean).join(" ")})); cancelbutton.innerHTML = set.buttons.cancel.text;
  cancelbutton.addEventListener("click", function(){area.innerHTML = "";reject();});
  const editarea = basebox.appendChild(Tags.div());
  hourbox.addEventListener("click",function(){
    (function refini(){
      editarea.innerHTML = "";
      [
        {arr:[{v:0},{v:[1,2,3,4,5],title:".."},{v:6},{v:[7,8,9,10],title:".."},{v:11}]},
        {arr:[{v:12},{v:[13,14,15,16,17],title:".."},{v:18},{v:[19,20,21,22],title:".."},{v:23}]}
      ].map(function(myset){
        let myr = editarea.appendChild(Tags.div({class:"container-fluid"})).appendChild(Tags.div({class:"row"}));;
        myset.arr.map(function(tempo){
          let b = myr.appendChild(Tags.button({type:"button",class:["col","btn","w-100"].concat(set.classes.numberbutton).filter(Boolean).join(" ")})); b.innerHTML = tempo.title ? tempo.title : tempo.v.toString();
          b.addEventListener("click", c_onclick(tempo));
        });
      });
      function c_onclick(tempo){return function(){
        if(tempo.title){
          refdetail(tempo.v);
        }else{hourbox.innerHTML = moment(new Date(2000,1,1,tempo.v,0,0)).format("HH"); editarea.innerHTML = "";}
      };}
      function refdetail(arr){
        editarea.innerHTML = "";
        let myrow3 = editarea.appendChild(Tags.div({class:"container-fluid"})).appendChild(Tags.div({class:"row"}));
        arr.map(function(tempv){
          let b2 = myrow3.appendChild(Tags.button({type:"button",class:["col","btn","w-100"].concat(set.classes.numberbutton).filter(Boolean).join(" ")})); b2.innerHTML = tempv.toString();
          b2.addEventListener("click", function(){hourbox.innerHTML = moment(new Date(2000,1,1,tempv,0,0)).format("HH"); editarea.innerHTML = "";});
        });
        let rb = myrow3.appendChild(Tags.button({type:"button",class:["col","btn","w-100"].concat(set.classes.undobutton).filter(Boolean).join(" ")})); rb.innerHTML = set.buttons.undo.text;
        rb.addEventListener("click", refini);
      }
    })();
  });
  minutebox.addEventListener("click", function(){
    (function refini(){
      editarea.innerHTML = "";
      [
        {arr:[{v:0},{v:[1,2,3,4],title:".."},{v:5},{v:[6,7,8],title:".."},{v:9}]},
        {arr:[{v:10},{v:[11,12,13,14],title:".."},{v:15},{v:[16,17,18],title:".."},{v:19}]},
        {arr:[{v:20},{v:[21,22,23,24],title:".."},{v:25},{v:[26,27,28],title:".."},{v:29}]},
        {arr:[{v:30},{v:[31,32,33,34],title:".."},{v:35},{v:[36,37,38],title:".."},{v:39}]},
        {arr:[{v:40},{v:[41,42,43,44],title:".."},{v:45},{v:[46,47,48],title:".."},{v:49}]},
        {arr:[{v:50},{v:[51,52,53,54],title:".."},{v:55},{v:[56,57,58],title:".."},{v:59}]}
      ].map(function(myset){
        let myr = editarea.appendChild(Tags.div({class:"container-fluid"})).appendChild(Tags.div({class:"row"}));;
        myset.arr.map(function(tempo){
          let b = myr.appendChild(Tags.button({type:"button",class:["col","btn","w-100"].concat(set.classes.numberbutton).filter(Boolean).join(" ")})); b.innerHTML = tempo.title ? tempo.title : tempo.v.toString();
          b.addEventListener("click", c_onclick(tempo));
        });
      });
      function c_onclick(tempo){return function(){
        if(tempo.title){
          refdetail(tempo.v);
        }else{minutebox.innerHTML = moment(new Date(2000,1,1,0,tempo.v,0)).format("mm"); editarea.innerHTML = "";}
      };}
      function refdetail(arr){
        editarea.innerHTML = "";
        let myrow3 = editarea.appendChild(Tags.div({class:"container-fluid"})).appendChild(Tags.div({class:"row"}));
        arr.map(function(tempv){
          let b2 = myrow3.appendChild(Tags.button({type:"button",class:["col","btn","w-100"].concat(set.classes.numberbutton).filter(Boolean).join(" ")})); b2.innerHTML = tempv.toString();
          b2.addEventListener("click", function(){minutebox.innerHTML = moment(new Date(2000,1,1,0,tempv,0)).format("mm"); editarea.innerHTML = "";});
        });
        let rb = myrow3.appendChild(Tags.button({type:"button",class:["col","btn","w-100"].concat(set.classes.undobutton).filter(Boolean).join(" ")})); rb.innerHTML = set.buttons.undo.text;
        rb.addEventListener("click", refini);
      }
    })();
  });
});};}

function c_select(set){return function(area,arr){return new Promise(function(resolve,reject){
  switch(set.type.toLowerCase()){
    case "table":{c_selecttable(set)(area,arr).then(resolve,reject);break;}
    case "card":{c_selectcard(set)(area,arr).then(resolve,reject);break;}
    default:{break;}
  }
});};}

function adjusttableselectiondef(set){
  if(!set.max){set.max = 1;}
  if(!set.classes){set.classes = {};}
  ["table","thead","th","tbody","tr","td","choosebutton","cancelbutton","keybox","searchbutton","selectbutton","removebutton","foldbutton","selectingarea"].map(function(s){
    if(!set.classes[s]){set.classes[s] = [];}
  });
  if(!set.options){set.options = {};}
  if(!set.options.cols){set.options.cols = [];}
  const tempdef = {choosebutton:"OK",cancelbutton:"CANCEL",searchbutton:"Search",selectbutton:"select",removebutton:"remove"};
  for(let buttonname in tempdef){
    if(!set.options[buttonname]){set.options[buttonname] = {};}
    if(!set.options[buttonname].text){set.options[buttonname].text = tempdef[buttonname];}
    if(!set.options[buttonname].classes){set.options[buttonname].classes = [];}
  }
  if(!set.options.keybox){set.options.keybox = {};}
  if(!set.options.keybox.placeholder){set.options.keybox.placeholder = "";}
  if(!set.options.keybox.classes){set.options.keybox.classes = [];}
  if(!set.options.searchcolumns){set.options.searchcolumns = [];}
  if(!set.functions){set.functions = {};}
  if(!set.functions.sort){set.functions.sort = function(a,b){return 1;};}
  if(!set.functions.getuniquevalue){set.functions.getuniquevalue = function(item){return JSON.stringify(item);};}
}

function adjustcardselectiondef(set){
  if(!set.max){set.max = 1;}
  if(!set.classes){set.classes = {};}
  ["card","header","body","footer","choosebutton","cancelbutton","keybox","searchbutton","selectbutton","removebutton","foldbutton","selectingarea"].map(function(s){
    if(!set.classes[s]){set.classes[s] = [];}
  });
  if(!set.options){set.options = {};}
  const tempdef = {choosebutton:"OK",cancelbutton:"CANCEL",searchbutton:"Search",selectbutton:"select",removebutton:"remove"};
  for(let buttonname in tempdef){
    if(!set.options[buttonname]){set.options[buttonname] = {};}
    if(!set.options[buttonname].text){set.options[buttonname].text = tempdef[buttonname];}
    if(!set.options[buttonname].classes){set.options[buttonname].classes = [];}
  }
  if(!set.options.keybox){set.options.keybox = {};}
  if(!set.options.keybox.placeholder){set.options.keybox.placeholder = "";}
  if(!set.options.keybox.classes){set.options.keybox.classes = [];}
  if(!set.options.searchcolumns){set.options.searchcolumns = [];}
  if(!set.options.buttons){set.options.buttons = [];}
  for(let pn in {header:1,body:1}){
    if(!set.options[pn]){set.options[pn] = {};}
    if(!set.options[pn].gettext){set.options[pn].gettext = function(item){return JSON.stringify(item);};}
    if(!set.options[pn].getclasses){set.options[pn].getclasses = function(){return [];};}
  }
  if(!set.functions){set.functions = {};}
  if(!set.functions.sort){set.functions.sort = function(a,b){return 1;};}
  if(!set.functions.getuniquevalue){set.functions.getuniquevalue = function(item){return JSON.tringify(item);};}
}

function c_selecttable(set){adjusttableselectiondef(set);return function(area,arr){return new Promise(function(resolve,reject){
  area.innerHTML = "";
  const myform = area.appendChild(Tags.div({class:"w-100 d-flex flex-row flex-nowrap justify-content-end"})).appendChild(Tags.form({class:"form-inline"}));
  const keybox = myform.appendChild(Tags.input({placeholder:(set && set.options && set.options.keybox && set.options.keybox.placeholder ? set.options.keybox.placeholder : ""),class:["form-control"].concat(set.classes.keybox).concat(set.options.keybox.classes).filter(Boolean).join(" ")}));
  const searchbutton = myform.appendChild(Tags.button({type:"button",class:["form-control","btn"].concat(set.classes.searchbutton).concat(set.options.searchbutton.classes).filter(Boolean).join(" ")})); searchbutton.innerHTML = set.options.searchbutton.text;
  const multichoosebutton = myform.appendChild(Tags.button({type:"button",class:["btn",(set.max === 1 ? "d-none" : null)].concat(set.classes.choosebutton).concat(set.options.choosebutton.classes).filter(Boolean).join(" ")})); multichoosebutton.innerHTML = set.options.choosebutton.text;
  const cancelbutton = myform.appendChild(Tags.button({type:"button",class:["form-control","btn"].concat(set.classes.cancelbutton).concat(set.options.cancelbutton.classes).filter(Boolean).join(" ")})); cancelbutton.innerHTML = set.options.cancelbutton.text;
  cancelbutton.addEventListener("click", function(){area.innerHTML = ""; reject();});
  const foldbutton = area.appendChild(Tags.button({type:"button",class:["btn","w-100",(set.max === 1 ? "d-none" : null)].concat(set.classes.foldbutton).filter(Boolean).join(" ")}));
  const div_selected = area.appendChild(Tags.div({class:["w-100","d-none"].concat(set.classes.selectingarea).filter(Boolean).join(" ")}));
  const t_selected = div_selected.appendChild(Tags.table({class:["table"].concat(set.classes.table).filter(Boolean).join(" ")}));
  t_selected.appendChild(Tags.thead({class:"d-none"})).appendChild(Tags.tr());
  const tbody_selected = t_selected.appendChild(Tags.tbody({class:[].concat(set.classes.tbody).filter(Boolean).join(" ")}));
  const tdiv = area.appendChild(Tags.div({class:["w-100"].join(" ")}));
  foldbutton.addEventListener("click", function(){div_selected.classList.toggle("d-none");});
  foldbutton.innerHTML = [document.querySelectorAll("#"+div_selected.getAttribute("id")+" tbody tr").length,"アイテム選択中"].join("");
  multichoosebutton.addEventListener("click", function(){resolve(Array.from(document.querySelectorAll("#"+div_selected.getAttribute("id")+" tbody tr")).map(function(card){return JSON.parse(card.getAttribute("name"));})); area.innerHTML = "";});
  function maketext(item){return set.options.searchcolumns.map(function(n){try{return item[n];}catch(e){return null;} }).filter(Boolean).join(" ");}
  function makefilter(keyword){let keyl = keyword.toUpperCase().replace(/　/g," ").split(" ").filter(Boolean), keylen = keyl.length; return function(item){let text = maketext(item).toUpperCase(), bin = true; for(let i = 0; i < keylen; i++){try{bin = bin && text.indexOf(keyl[i]) >= 0;}catch(e){} if(!bin){break;}} return bin;};}
  function reflect(keyword){
    tdiv.innerHTML = "";
    const t = tdiv.appendChild(Tags.table({class:["table"].concat(set.classes.table).filter(Boolean).join(" ")})), thead = t.appendChild(Tags.thead({class:[].concat(set.classes.thead).filter(Boolean).join(" ")}));
    const thr = thead.appendChild(Tags.tr()), tbody = t.appendChild(Tags.tbody({class:[].concat(set.classes.tbody).filter(Boolean).join(" ")}));
    set.options.cols.map(function(s){thr.appendChild(Tags.th({class:[].concat(set.classes.th).filter(Boolean).join(" ")})).innerHTML = s;});
    thr.appendChild(Tags.th({class:[].concat().filter(Boolean).join(" ")})).innerHTML = "";
    (keyword && keyword !== "" ? arr.filter(makefilter(keyword)) : arr).sort(set.functions.sort).map(function(item){
      const r = tbody.appendChild(Tags.tr({name:JSON.stringify(item),class:[].concat(set.classes.tr).filter(Boolean).join(" ")}));
      set.options.cols.map(function(col){
        r.appendChild(Tags.td({class:[].concat(set.classes.td).filter(Boolean).join(" ")})).innerHTML = item[col];
      });
      if(set.max === 1){
        const choosebutton = r.appendChild(Tags.td({class:[].concat(set.classes.td).filter(Boolean).join(" ")})).appendChild(Tags.button({type:"button",class:["btn"].concat(set.classes.choosebutton).concat(set.options.choosebutton.classes).filter(Boolean).join(" ")}));
        choosebutton.innerHTML = set.options.choosebutton.text;
        choosebutton.addEventListener("click", function(){area.innerHTML = "";resolve(item);});
      }else{
        const tempbtd = r.appendChild(Tags.td({class:[].concat(set.classes.td).filter(Boolean).join(" ")}));
        const selectbutton = tempbtd.appendChild(Tags.button({type:"button",class:["btn"].concat(set.classes.selectbutton).concat(set.options.selectbutton.classes).filter(Boolean).join(" ")}));
        selectbutton.innerHTML = set.options.selectbutton.text;
        const removebutton = tempbtd.appendChild(Tags.button({type:"button",class:["btn","d-none"].concat(set.classes.removebutton).concat(set.options.removebutton.classes).filter(Boolean).join(" ")}));
        removebutton.innerHTML = set.options.removebutton.text;

        selectbutton.addEventListener("click", function(){
          selectbutton.classList.add("d-none");
          removebutton.classList.remove("d-none");
          tbody_selected.appendChild(r);
          foldbutton.innerHTML = [document.querySelectorAll("#"+div_selected.getAttribute("id")+" tbody tr").length,"アイテム選択中"].join("");
        });
        removebutton.addEventListener("click", function(){
          r.parentNode.removeChild(r);
          foldbutton.innerHTML = [document.querySelectorAll("#"+div_selected.getAttribute("id")+" tbody tr").length,"アイテム選択中"].join("");
        });
      }
    });
  }
  searchbutton.addEventListener("click", function(){reflect(keybox.value);});
  setTimeout(function(){searchbutton.click();},1);
});};}

function c_selectcard(set){adjustcardselectiondef(set);return function(area,arr){return new Promise(function(resolve,reject){
  area.innerHTML = "";
  const myform = area.appendChild(Tags.div({class:"w-100 d-flex flex-row flex-nowrap justify-content-end"})).appendChild(Tags.form({class:"form-inline"}));
  const keybox = myform.appendChild(Tags.input({placeholder:(set && set.options && set.options.keybox && set.options.keybox.placeholder ? set.options.keybox.placeholder : ""),class:["form-control"].concat(set.classes.keybox).concat(set.options.keybox.classes).filter(Boolean).join(" ")}));
  const searchbutton = myform.appendChild(Tags.button({type:"button",class:["form-control","btn"].concat(set.classes.searchbutton).concat(set.options.searchbutton.classes).filter(Boolean).join(" ")})); searchbutton.innerHTML = set.options.searchbutton.text;
  const multichoosebutton = myform.appendChild(Tags.button({type:"button",class:["btn",(set.max === 1 ? "d-none" : null)].concat(set.classes.choosebutton).concat(set.options.choosebutton.classes).filter(Boolean).join(" ")})); multichoosebutton.innerHTML = set.options.choosebutton.text;
  const cancelbutton = myform.appendChild(Tags.button({type:"button",class:["form-control","btn"].concat(set.classes.cancelbutton).concat(set.options.cancelbutton.classes).filter(Boolean).join(" ")})); cancelbutton.innerHTML = set.options.cancelbutton.text;
  cancelbutton.addEventListener("click", function(){area.innerHTML = ""; reject();});
  const foldbutton = area.appendChild(Tags.button({type:"button",class:["btn","w-100",(set.max === 1 ? "d-none" : null)].concat(set.classes.foldbutton).filter(Boolean).join(" ")}));
  const div_selected = area.appendChild(Tags.div({class:["w-100","d-none"].concat(set.classes.selectingarea).filter(Boolean).join(" ")}));
  const fbox_selected = div_selected.appendChild(Tags.div({class:"w-100 d-flex flex-row flex-wrap"}));
  foldbutton.addEventListener("click", function(){div_selected.classList.toggle("d-none");});
  const fbox = area.appendChild(Tags.div({class:"w-100 d-flex flex-row flex-wrap"}));
  foldbutton.innerHTML = [fbox_selected.childNodes.length,"アイテム選択中"].join("");
  multichoosebutton.addEventListener("click", function(){resolve(Array.from(fbox_selected.childNodes).map(function(card){return JSON.parse(card.getAttribute("name"));}));area.innerHTML = "";});
  function maketext(item){return set.options.searchcolumns.map(function(n){try{return item[n];}catch(e){return null;} }).filter(Boolean).join(" ");}
  function makefilter(keyword){let keyl = keyword.toUpperCase().replace(/　/g," ").split(" ").filter(Boolean), keylen = keyl.length; return function(item){let text = maketext(item).toUpperCase(), bin = true; for(let i = 0; i < keylen; i++){try{bin = bin && text.indexOf(keyl[i]) >= 0;}catch(e){} if(!bin){break;}} return bin;};}
  function reflect(keyword){
    fbox.innerHTML = "";
    (keyword && keyword !== "" ? arr.filter(makefilter(keyword)) : arr).sort(set.functions.sort).map(function(item){
      const count_exists = Array.from(fbox_selected.childNodes).filter(function(ele){return set.functions.getuniquevalue(JSON.parse(ele.getAttribute("name"))) === set.functions.getuniquevalue(item);}).length;
      if(count_exists > 0){return;}
      const card = fbox.appendChild(Tags.div({name:JSON.stringify(item),class:["card"].concat(set.classes.card).filter(Boolean).join(" ")}));
      const chead = card.appendChild(Tags.div({class:["card-header"].concat(set.classes.header).concat(set.options.header.getclasses(item)).filter(Boolean).join(" ")})); chead.innerHTML = set.options.header.gettext(item);
      const cbody = card.appendChild(Tags.div({class:["card-body"].concat(set.classes.body).concat(set.options.body.getclasses(item)).filter(Boolean).join(" ")})); cbody.innerHTML = set.options.body.gettext(item);
      const cfoot = card.appendChild(Tags.div({class:["card-footer"].concat(set.classes.footer).filter(Boolean).join(" ")}));
      set.options.buttons.map(function(bdef){
        const myb = cfoot.appendChild(Tags.button({type:"button",class:["btn"].concat(bdef.classes).filter(Boolean).join(" ")})); myb.innerHTML = bdef.text;
        myb.addEventListener("click", function(){bdef.onclick(item);});
      });
      if(set.max === 1){
        const choosebutton = cfoot.appendChild(Tags.button({type:"button",class:["btn"].concat(set.classes.choosebutton).concat(set.options.choosebutton.classes).filter(Boolean).join(" ")})); choosebutton.innerHTML = set.options.choosebutton.text;
        choosebutton.addEventListener("click", function(){area.innerHTML = "";resolve(item);});
      }else{
        const selectbutton = cfoot.appendChild(Tags.button({type:"button",class:["btn"].concat(set.classes.selectbutton).concat(set.options.selectbutton.classes).filter(Boolean).join(" ")})); selectbutton.innerHTML = set.options.selectbutton.text;
        const removebutton = cfoot.appendChild(Tags.button({type:"button",class:["btn","d-none"].concat(set.classes.removebutton).concat(set.options.removebutton.classes).filter(Boolean).join(" ")})); removebutton.innerHTML = set.options.removebutton.text;
        removebutton.addEventListener("click", function(){
          card.parentNode.removeChild(card);
          foldbutton.innerHTML = [fbox_selected.childNodes.length,"アイテム選択中"].join("");
        });
        selectbutton.addEventListener("click", function(){
          selectbutton.classList.add("d-none");
          removebutton.classList.remove("d-none");
          fbox_selected.appendChild(card);
          foldbutton.innerHTML = [fbox_selected.childNodes.length,"アイテム選択中"].join("");
        });
      }
    });
  }
  searchbutton.addEventListener("click", function(){reflect(keybox.value);});
  setTimeout(function(){searchbutton.click();},1);
});};}
